#include <bits/stdc++.h>

using namespace std; 
using ll = long long; 
using vi = vector<int>; 


bool dfs(int a, int L, vector<vi> & g, vi & btoa, vi & A, vi & B){
    if (A[a] != L) return 0; 
    A[a] = -1; 
    for (int b : g[a]) if (B[b] == L + 1){
        B[b] = 0; 
        if (btoa[b] == -1 || dfs(btoa[b], L + 1, g, btoa, A, B))
            return btoa[b] = a, 1; 
    }
    return 0; 
}

int hopcroftKarp(vector<vi> & g, vi & btoa){
    int res = 0; 
    vi A(g.size()), B(btoa.size()), cur, next; 
    for (;;){
        fill(A.begin(), A.end(), 0); 
        fill(B.begin(), B.end(), 0); 
        cur.clear(); 
        for (int a : btoa) if (a != -1) A[a] = -1; 
        for (int a = 0; a < g.size(); ++a) if (A[a] == 0) cur.push_back(a); 
        for (int lay = 1;; lay++){
            bool islast = 0; 
            next.clear(); 
            for (int a : cur) for (int b : g[a]){
                if (btoa[b] == -1){
                    B[b] = lay; 
                    islast = 1;  
                }
                else if (btoa[b] != a && B[b]){
                    B[b] = lay; 
                    next.push_back(btoa[b]); 
                }
            } 
            if (islast) break; 
            if (next.empty()) return res; 
            for (int a : next) A[a] = lay; 
            cur.swap(next); 
        }
        for (int a = 0; a < g.size(); ++a){
            res += dfs(a, 0, g, btoa, A, B); 
        }
    } 
}


bool check(int mid, vector<int> & a, vector<int> & b){
    int n = a.size(); 

    int cnt = 0; 
    vector<vi> g(a.size(), vi()); 
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < n; ++j){
            if (abs(a[i] - b[j]) >= mid) {
                g[i].push_back(j), cnt++; 
                cout << i << " " << j << endl;
            }
        }
    }

    vi btoa(n, -1); 
    hopcroftKarp(g, btoa); 
    
    cout << mid << ": ";
    for(auto a : btoa) cout << a << " ";
    cout << endl;
    for (int a : btoa) if (a == -1) return 0; 
        cout << "(" << mid <<")"<< endl;
    return 1; 
}


void solve(){
    int n; cin >> n; 
    vector<int> a(n), b(n); 

    for (int i = 0; i < n; ++i) cin >> a[i]; 
    for (int i = 0; i < n; ++i) cin >> b[i];

    int first = 0, last = 1e9; 
    while (first < last){
        int mid = (first + last + 1) / 2; 
        if (check(mid, a, b)) first = mid; 
        else last = mid - 1; 
    }
    cout << first << "\n"; 
}

int main(){
    ios_base::sync_with_stdio(false); 
    cin.tie(0); 
    int t; cin >> t; 
    while (t--) solve(); 
}