#include<bits/stdc++.h>
using namespace std;
using ll = long long;
vector<string> curg;
vector<string> res;
using pii = pair<int, int>;
int r,c;
int dx[4] = {1, -1, 0, 0};
int dy[4] = {0, 0, -1, 1};

vector<pii> getnxt(pii cur) {
    vector<pii> res;
    for(int dir = 0; dir < 4; dir++) {
        int nx = cur.first + dx[dir];
        int ny = cur.second + dy[dir];
        if(nx >= 0 && nx < r && ny >= 0 && ny < c) {
            res.push_back({nx, ny});
        }
    }
    return res;
}

pair<int, int> get_removable(pair<int, int> keep) {
    bool vis[50][50];
    memset(vis, 0, false);
    vector<pii> q{keep};
    vis[keep.first][keep.second] = 1;
    int qidx = 0;
    while(qidx < q.size()) {
        pii cur = q[qidx++];
        for(auto nxt : getnxt(cur)) {
            if(curg[nxt.first][nxt.second] == '*' && !vis[nxt.first][nxt.second]) {
                vis[nxt.first][nxt.second] = 1;
                q.push_back(nxt);
            }
        }
    }
    return q.back();
}

vector<pii> removable_list(pii keep) {
    bool vis[50][50];
    memset(vis, 0, false);
    vector<pii> q{keep};
    vis[keep.first][keep.second] = 1;
    int qidx = 0;
    while(qidx < q.size()) {
        pii cur = q[qidx++];
        for(auto nxt : getnxt(cur)) {
            if(curg[nxt.first][nxt.second] == '*' && !vis[nxt.first][nxt.second]) {
                vis[nxt.first][nxt.second] = 1;
                q.push_back(nxt);
            }
        }
    }
    reverse(q.begin(), q.end());
    return q;
}

vector<pii> addable_list(pii keep) {
    bool vis[50][50];
    memset(vis, 0, false);
    vector<pii> q{keep};
    vis[keep.first][keep.second] = 1;
    int qidx = 0;
    while(qidx < q.size()) {
        pii cur = q[qidx++];
        for(auto nxt : getnxt(cur)) {
            if(res[nxt.first][nxt.second] == '*' && !vis[nxt.first][nxt.second]) {
                vis[nxt.first][nxt.second] = 1;
                q.push_back(nxt);
            }
        }
    }
    return q;
}

vector<pii> get_path(pii stt, pii end) {
    bool vis[50][50];
    memset(vis, 0, false);
    vector<pii> q{stt};
    vector<int> par{-1};
    vis[stt.first][stt.second] = 1;
    int qidx = 0;
    while(qidx < q.size()) {
        pii cur = q[qidx++];
        for(auto nxt : getnxt(cur)) {
            if(!vis[nxt.first][nxt.second]) {
                vis[nxt.first][nxt.second] = 1;
                q.push_back(nxt);
                par.push_back(qidx - 1);
            }
        }
    }
    for(int i = 0; i < q.size(); i++) {
        if(q[i] == end) {
            int tmp = par[i];
            vector<pii> res{q[tmp]};
            while(i != -1) {
                res.push_back(q[i]);
                i = par[i];
            }
            reverse(res.begin(), res.end());
            return res;
        }
    }
    return {};
}

pii get_cur_in() {
    for(int i = 0; i < r; i++) for(int j = 0; j < r; j++) {
        if(curg[i][j] == '*') return {i, j};
    }
    assert(0);
    return {-1, -1};
}

pii get_res_in() {
    for(int i = 0; i < r; i++) for(int j = 0; j < r; j++) {
        if(res[i][j] == '*') return {i, j};
    }
    assert(0);
    return {-1, -1};
}

vector<pair<pii, pii>> ans;


int main() {
    cin >> r >> c;
    curg.resize(r);
    res.resize(r);
    for(auto & str : curg) cin >> str;
    for(auto & str : res) cin >> str;
    pii target = get_res_in();
    vector<pii> path = get_path(get_cur_in(), target);
    if(path.size() == 0) {
        cout << "NO" << endl;
        return 0;
    }
    pair<int, int> prev = path[0];
    for(auto [x, y] : path) {
        if(curg[x][y] == '*') {
            prev = {x, y};
            continue;
        }
        pii removed = get_removable(prev);
        ans.push_back({removed, {x, y}});
        curg[removed.first][removed.second] = '.';
        curg[x][y] = '*';
    }
    vector<pii> rem = removable_list(target);
    vector<pii> add = addable_list(target);
    for(int i = 0; i < rem.size(); i++) {
        pii remd = rem[i];
        pii added = {-1, -1};
        for(auto p : add) {
            if(curg[p.first][p.second] == '*') continue;
            added = p;
            break;
        }
        if(remd == added) continue;
        ans.push_back({remd, added});
        curg[remd.first][remd.second] = '.';
        curg[added.first][added.second] = '*';
    }
    cout << "YES" << endl;
    cout << ans.size() << endl;
    for(auto [a, b] : ans) {
        auto [ax, ay] = a;
        auto [bx, by] = b;
        cout << ax << " " << ay << " " << bx << " " << by << "\n";
    }
    for(int i= 0; i < r; i++) {
        assert(curg[i] == res[i]);
    }
}